/*
Stochastic Theory Education through Visualization Environment (STEVE) 2.0
Robert Florence, Tennessee Tech University
Color.cpp - This class contains a color in RGB format.
Last Modified: Jun 25, 2008
*/

#include "Color.h"

/*
create a white color
*/
Color::Color()
{
    red = 1.0f;
    green = 1.0f;
    blue = 1.0f;
}

/*
create a custom color
r, g, b: red, green, and blue values
*/
Color::Color(float r, float g, float b)
{
    red = clamp(r);
    green = clamp(g);
    blue = clamp(b);
}

/*
get color information
return: color's red, green, or blue value
*/
float Color::getRed()
{
    return red;
}

float Color::getGreen()
{
    return green;
}

float Color::getBlue()
{
    return blue;
}

/*
change the RGB value of the color
r, g, b: new red, green, and blue values
*/
void Color::setRGB(float r, float g, float b)
{
    red = clamp(r);
    green = clamp(g);
    blue = clamp(b);
}

/*
restrict a color value to (0.0-1.0)
c: color value to clamp
return: 0.0 if c is below 0.0, 1.0 if c is above 1.0, otherwise c
*/
float Color::clamp(float c)
{
    if (c < 0.0f)
        c = 0.0f;
    else if (c > 1.0f)
        c = 1.0f;
        
    return c;
}
